# Locked-dict

Implementation of dict supporting context managed thread safe and mutable iterations through a lock.

[License: MIT](https://github.com/sthagen/locked-dict/blob/default/LICENSE) | 
[Country of origin: Switzerland](https://git.sr.ht/~sthagen/locked-dict/tree/default/item/COUNTRY-OF-ORIGIN) | 
[Export control classification number(ECCN): EAR99](https://git.sr.ht/~sthagen/locked-dict/tree/default/item/EXPORT-CONTROL-CLASSIFICATION-NUMBER)

Third party dependencies are documented in the folder [third-party](docs/third-party/README.md).

[![version](https://img.shields.io/pypi/v/locked-dict.svg?style=flat)](https://pypi.python.org/pypi/locked-dict/)
[![downloads](https://static.pepy.tech/badge/locked-dict/month)](https://pepy.tech/project/locked-dict)
[![wheel](https://img.shields.io/pypi/wheel/locked-dict.svg?style=flat)](https://pypi.python.org/pypi/locked-dict/)
[![supported-versions](https://img.shields.io/pypi/pyversions/locked-dict.svg?style=flat)](https://pypi.python.org/pypi/locked-dict/)
[![supported-implementations](https://img.shields.io/pypi/implementation/locked-dict.svg?style=flat)](https://pypi.python.org/pypi/locked-dict/)
[![maintenance-status](https://img.shields.io/github/commit-activity/y/sthagen/locked-dict.svg?style=flat)](https://git.sr.ht/~sthagen/locked-dict/log)

## Documentation

User and developer [documentation of locked-dict](https://codes.dilettant.life/docs/locked-dict).

## Bug Tracker

Any feature requests or bug reports shall go to the [todos of locked-dict](https://todo.sr.ht/~sthagen/locked-dict).

## Primary Source repository

The main source of `locked-dict` is on a mountain in central Switzerland.
We use distributed version control (git).
There is no central hub.
Every clone can become a new source for the benefit of all.
The preferred public clones of `locked-dict` are:

* [on codeberg](https://codeberg.org/sthagen/locked-dict) - a democratic community-driven, non-profit software development platform operated by Codeberg e.V.
* [at sourcehut](https://git.sr.ht/~sthagen/locked-dict) - a collection of tools useful for software development.

## Contributions

Please do not submit "pull requests" (I found no way to disable that "feature" on GitHub).
If you like to share small changes under the repositories license please kindly do so by sending a patchset.
You can either send such a patchset per email using [git send-email](https://git-send-email.io) or 
if you are a sourcehut user by selecting "Prepare a patchset" on the summary page of your fork at [sourcehut](https://git.sr.ht/).

# Status

Production/stable.

**Note** The default branch is `default`.
